/*
Gentooza's Sudokus Resolver

Copyright(2018):  Joaquín Cuéllar <joa.cuellar (at) riseup.net>

This app is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This app is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this app.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <iostream>
#include <vector>
#include <limits>
#include <sstream>
#include <algorithm>

#include "defines.h"
#ifndef _CELL_
#define _CELL_

int getInt();

class cell
{
 public:
  cell(int num);
  cell();
  ~cell(){return;};

  int setValue(int value);
  int retValue(){return iValue;};
  int setDefined(int newDefined){defined = newDefined;};
  int retDefined(){return defined;};
  int setCouldBe(std::vector <int> newCouldBe){couldBe = newCouldBe;};
  std::vector <int> retCouldBe(){return couldBe;};
  int hasSollution();
  int solve();
  int removeFrmCouldBe(int number){/*TODO*/ return 0;};
  int removeFrmCouldBe(std::vector <int> vectorToRemove);
  std::string retPrettyStatus();

  int setPos(int col, int row);
  std::vector<int> retPos();
  
 private:
  int iValue;
  int defined;
  std::vector <int> couldBe;
  int iRow;
  int iCol;
};

#endif
